var selectedMarker = null;
var selectedMarkerColor = "red";

var ligIcon = L.icon({
    iconUrl: 'images/markerSTeamer_27_43.png',
    iconSize:     [27, 43], // size of the icon
    iconAnchor:   [14, 43] // point of the icon which will correspond
});

function createProjectLayer(projectName, projectsData, partnersData, couleur, centerLat, centerLong, zoomLevel) {
    var layer = new L.LayerGroup();
    var i;
    var marker;
    var projInfo = null;

    for (i = 0; i < projectsData.length; i++) {
        if (projectsData[i].project === projectName) {
            projInfo = projectsData[i];
        }
    }
    for (i = 0; i < partnersData.length; i++) {
        //if (partnersData[i].projects === projectName) {
		var pprojects = partnersData[i].projects ;
		if ((pprojects.indexOf(projectName)) > -1) {
            marker = L.circleMarker([partnersData[i].lat, partnersData[i].lng], {color: couleur, fillColor: couleur, fillOpacity: 0.5}); // ,10, {color: 'red', fillColor: 'red', fillOpacity: 0.5} L.marker([partnersData[i].lat, partnersData[i].lng]);
            marker.setRadius(6);
            marker.addTo(layer);
            marker.info = partnersData[i];
             marker.infoProject = projInfo;
//            var popup = '';
//            for (var prop in partnersData[i]) {
//                if (prop === "web site") {
//                    popup += '<b>' + prop + '</b><br /><a href="' + partnersData[i][prop] + '">' + partnersData[i][prop] + '</a> <br /><br />';
//                }
//                else {
//                    popup += '<b>' + prop + '</b><br />' + partnersData[i][prop] + '<br /><br />';
//                }
//            }
//            marker.bindPopup(popup);
            marker.on('mouseover', function(e) {
                if (selectedMarker) {
                    selectedMarker.setRadius(6);
                    selectedMarker.setStyle( {fillColor: selectedMarkerColor});
                }
                selectedMarker = this;
                                selectedMarkerColor = this.options.fillColor;
                $("#partnerDiv").html(this.info.partner + '<br><a href="' + this.info["web site"] + '" target="_blank">' + this.info["web site"] + '</a>');
                $("#projectDiv").html(this.infoProject.description);


                this.setStyle( {fillColor: 'yellow'});;
                this.setRadius(9);
            });
            marker.on('mouseout', function(e) {
             //   this.setRadius(6);
            });
        }

    }
    layer.StyledLayerControl = {
        legendColor: couleur,
        layerCenter: L.latLng(centerLat, centerLong),
        layerZoom: zoomLevel,
        projectInfo: projInfo
    };
    return layer;
}

function init() {
    // Google layers
    var g_roadmap = new L.Google('ROADMAP');
    var g_satellite = new L.Google('SATELLITE');
    var g_terrain = new L.Google('TERRAIN');

    // OSM layers
    var osmUrl = 'http://{s}.tile.osm.org/{z}/{x}/{y}.png';
    var osmAttrib = 'Map data © <a href="http://openstreetmap.org">OpenStreetMap</a> contributors';
    var osm = new L.TileLayer(osmUrl, {attribution: osmAttrib});

    // Bing layers
    var bing1 = new L.BingLayer("AvZ2Z8Jve41V_bnPTe2mw4Xi8YWTyj2eT87tSGSsezrYWiyaj0ldMaVdkyf8aik6", {type: 'Aerial'});
    var bing2 = new L.BingLayer("AvZ2Z8Jve41V_bnPTe2mw4Xi8YWTyj2eT87tSGSsezrYWiyaj0ldMaVdkyf8aik6", {type: 'Road'});


    var map = L.map('map', {
        center: [-16, -54],
        zoom: 4
    });

    map.addLayer(g_roadmap);

    var baseMaps = [
        {
            groupName: "Google Base Maps",
            expanded: true,
            layers: {
                "Satellite": g_satellite,
                "Road Map": g_roadmap,
                "Terreno": g_terrain
            }
        }, {
            groupName: "OSM Base Maps",
            layers: {
                "OpenStreetMaps": osm
            }
        }/*, {
         groupName : "Bing Base Maps",
         layers    : {
         "Satellite" : bing1,
         "Road"      : bing2
         }
         } */
    ];
	
/*
	function createInternationalProjects() {
		var InternationalProjects = " ";
		for (i = 0; i < projects.length; i++) {			
			if (projects[i].level === 'International') {
				InternationalProjects = InternationalProjects + ' "' + projects[i].project + '" : ' +  'createProjectLayer( "' + projects[i].project + '", projects, partners, ' + '"blue"' + ', 45.19, 5.77, 2)' + ',' ;			
			}	
		}
	  return InternationalProjects;
	}
*/
	
	function createLevelProjects(level, levelcolor, levelzoom) {
		var ListProjects = " ";
		for (i = 0; i < projects.length; i++) {			
			if (projects[i].level === level) {
				ListProjects = ListProjects + ' "' + projects[i].project + '" : ' +  'createProjectLayer( "' + projects[i].project + '", projects, partners, ' + levelcolor + ', 45.19, 5.77,' + levelzoom + ')' + ',' ;			
			}	
		}
	  return ListProjects;
	}

	//alert (createLevelProjects('Local', '"red"', '7'));
	
	var overlayers = "[ "
		+ "{groupName: " + '"International Projects"' + ", expanded: false, layers: { " + 	createLevelProjects("International", '"red"', '2') + "}}," 
	    + "{groupName: " + '"National Projects"' + ", expanded: false, layers: { " + 	createLevelProjects("National", '"blue"', '5') + "}}," 
		+ "{groupName: " + '"Local Projects"' + ", expanded: false, layers: { " + 	createLevelProjects("Local", '"orange"', '10') + "}}," 	
		+ "];" ;
	
	var overlays = eval(overlayers);
	
	
//alert(overlayers);
 /*   
	var overlays = [
        {
            groupName: "International Projects",
            expanded: false,
            layers: { 
				// pour automatiser lajout de couches	
				//createInternationalProjects();
                "COST TD1202 (EU-COST, 2012-2016)": createProjectLayer("COST TD1202 (EU-COST, 2012-2016)", projects, partners, "red", 45.19, 5.77, 2),
				"COIN (NRCan, 2014-2016)": createProjectLayer("COIN (NRCan, 2014-2016)", projects, partners, 'orange', 45.19, 5.77, 2),
				"Data Base I (EU-ESPON, 2008-2011)": createProjectLayer("Data Base I (EU-ESPON, 2008-2011)", projects, partners, 'blue', 45.19, 5.77, 2),
				"Data Base II (EU-ESPON, 2011-2014)": createProjectLayer("Data Base II (EU-ESPON, 2011-2014)", projects, partners, 'blue', 45.19, 5.77, 2),

            }
        }, {
            groupName: "National Projects",
            expanded: false,
            layers: {
                "URBASIS (ANR, 2009-2013)": urbasis_layer = createProjectLayer("URBASIS (ANR, 2009-2013)", projects, partners, 'blue', 45.19, 5.77, 5),
                "MOANO (ANR, 2010-2014)": createProjectLayer("MOANO (ANR, 2010-2014)", projects, partners, 'red', 45.19, 5.77, 5),
				"BDHI (MEDDE, 2010-2014)": createProjectLayer("BDHI (MEDDE, 2010-2014)", projects, partners, 'orange', 45.19, 5.77, 5)
            }
			
        }, {
            groupName: "Local projects",
            expanded: false,
            layers: {
                "HyperAtlas Welfare (CNRS-PEPS, 2013-2013)": createProjectLayer("HyperAtlas Welfare (CNRS-PEPS, 2013-2013)", projects, partners, 'green', 45.19, 5.77, 7),
				"CTRD (INNOVACS, 2013-2014)": createProjectLayer("CTRD (INNOVACS, 2013-2014)", projects, partners, 'green', 45.19, 5.77, 7)
				
            }
        }
    ];
*/


    var options = {
        container_width: "300px",
        group_maxHeight: "80px",
        //container_maxHeight : "350px", 
        exclusive: false
    };

    var control = L.Control.styledLayerControl(baseMaps, overlays, options);
    map.addControl(control);

    // test for adding new base layers dynamically
    // to create a new group simply add a layer with new group name
    control.addBaseLayer(bing1, "Bing Satellite", {groupName: "Bing Maps", expanded: true});
    control.addBaseLayer(bing2, "Bing Road", {groupName: "Bing Maps"});


L.marker([45.194033, 5.767818600000055], {icon: ligIcon}).addTo(map);
    //control.removeLayer( corn_sp );

    //control.removeGroup( "Rio de Janeiro");

//    var popup = L.popup()
//            .setLatLng([-16, -54])
//            .setContent("The data that appears in this application are fictitious and do not represent actual data!")
//            .openOn(map);
}